LCDDB 	EQU P1
RS 		EQU P2.0
E 		EQU P2.1
RW		EQU P2.2
U 		EQU P0.0
D 		EQU P0.1
R 		EQU P0.2
L 		EQU P0.3
T2CON EQU 0C8H
T2MOD EQU 0C9H
RCAP2L EQU 0CAH
RCAP2H	EQU 0CBH
TL2	EQU 0CCH
TH2 EQU 0CDH

ORG 00H
			LJMP MAIN
ORG 03H							
			LJMP TRANSFER		;exint0
ORG 13H							
			LJMP JOYSTICK		;exint1
ORG 30H
MAIN:		MOV P0,#0FFH		;make P0 as input

			MOV R2,#15	;0FH		;y scale (group) (0~30)
			MOV R3,#10	;0AH		;x scale (0~20)
			
			MOV TMOD,#21H		;timers config
			;MOV TH1,#0F3H			;seial config;buad rate:12Mhz/12/32/1=31248
			;MOV SCON,#40H
			;MOV PCON,#80H		;baud rate*2=62496
			;SETB TR1
			MOV RCAP2L,#0B2H	;set RCAP2L
			MOV RCAP2H,#0FFH	;set RCAP2H
			MOV T2CON,#34H		;set TR2=1 in T2CON
			MOV SCON,#50H
		
			
			MOV R0,#30H			;RAM location for saving input data
			MOV @R0,#00H
			
			;SETB IP.2
			MOV IE,#10010101B	;enable ints.
			
			ACALL DELAY
			ACALL LCD
			SJMP $

			
JOYSTICK:	MOV A,R2			;exint1;check keyboard;is an ISR;if x or y =0 dont check them
			JZ JOYSTICK11		;if x or y is at their limit dont check it again
			JNB D,DOWN
JOYSTICK11:	JNB U,UP
			MOV A,R3
			JZ JOYSTICK12
			JNB L,LEFT
JOYSTICK12:	JNB R,RIGHT
UP:			ACALL DELAY
			MOV A,R2
			CLR C
			SUBB A,#30
			JNC NOUP
			INC R0
			MOV @R0,#01H
			INC R2
NOUP:		RETI
DOWN:		ACALL DELAY
			INC R0
			MOV @R0,#02H
			DEC R2
			RETI
RIGHT:		ACALL DELAY
			MOV A,R3
			CLR C
			SUBB A,#20
			JNC NORIGH
			INC R0
			MOV @R0,#03H
			INC R3
NORIGH:		RETI
LEFT:		ACALL DELAY
			INC R0
			MOV @R0,#04H
			DEC R3
			RETI
			
TRANSFER:	CJNE R0,#30H,TRANSFER1		;int0;if there is no data send nothing
			RETI
TRANSFER1:	MOV SBUF,@R0				;if there is data send it
			JNB TI,$
			CLR TI
			MOV @R0,#00H
			DEC R0
			ACALL LCD
			RETI	

LCD:		MOV A,#38H			;write LCD
			ACALL COMNWRT
			ACALL DELAY2
			MOV A,#0EH
			ACALL COMNWRT
			ACALL DELAY2
			MOV A,#01H
			ACALL COMNWRT
			ACALL DELAY2
			MOV A,#06H
			ACALL COMNWRT
			ACALL DELAY2
			MOV A,#84H
			ACALL COMNWRT
			ACALL DELAY2
			
			MOV A,#'X'
			ACALL DATAWRT
			ACALL DELAY2
			MOV A,#':'
			ACALL DATAWRT
			ACALL DELAY2
			MOV A,R3
			ACALL HEX2ASCH
			ACALL DATAWRT
			ACALL DELAY2
			MOV A,R3
			ACALL HEX2ASCL
			ACALL DATAWRT
			ACALL DELAY2
			
			
			MOV A,#0C8H
			ACALL COMNWRT
			ACALL DELAY2
			ACALL DELAY2
			MOV A,#'Y'
			ACALL DATAWRT
			ACALL DELAY2
			MOV A,#':'
			ACALL DATAWRT
			ACALL DELAY2
			MOV A,R2
			ACALL HEX2ASCH
			ACALL DATAWRT
			ACALL DELAY2
			MOV A,R2
			ACALL HEX2ASCL
			ACALL DATAWRT
			ACALL DELAY2
			RET

HEX2ASCH:	MOV R5,A		;for converting 0~1E hex high byte to assci
			CLR C
			SUBB A,#0AH
			JC L11
			MOV A,R5
			CLR C
			SUBB A,#14H
			JC L12
			MOV A,R5
			CLR C
			SUBB A,#1EH
			JC L13
			MOV A,#33H
			RET
L11:		MOV A,#30H
			RET
L12:		MOV A,#31H
			RET
L13:		MOV A,#32H
			RET
			
HEX2ASCL:	MOV R5,A		;for converting 0~1E hex low byte to assci
			CLR C
			SUBB A,#0AH
			JC L21
			MOV A,R5
			CLR C
			SUBB A,#14H
			JC L22
			MOV A,R5
			CLR C
			SUBB A,#1EH
			JC L23
			MOV A,#30H
			RET
L21:		MOV A,R5
			ADD A,#30H
			RET
L22:		MOV A,R5
			ADD A,#06H
			ANL A,#0FH
			ADD A,#30H
			RET
L23:		MOV A,R5
			ADD A,#06H
			ADD A,#06H
			ANL A,#0FH
			ADD A,#30H
			RET
			
COMNWRT:	MOV LCDDB,A		;for writing LCD commands
			CLR RS
			CLR RW
			NOP
			NOP
			NOP
			SETB E
			NOP
			NOP
			NOP
			CLR E
			RET
			
DATAWRT:	MOV LCDDB,A		;for writing LCD datas
			SETB RS
			CLR RW
			NOP
			NOP
			NOP
			SETB E
			NOP
			NOP
			NOP
			CLR E
			RET	

;READY:		SETB P1.7
;			CLR RS
;			SETB RW
;AGAIN1:		CLR E
;			SETB E
;			JB P1.7,AGAIN1
;			RET
			
DELAY2:		MOV R4,#50			;delay for 25ms
HERE:		MOV R5,#255
			DJNZ R5,$
			DJNZ R4,HERE
			RET
						
DELAY:		MOV R4,#10			;delay for 50ms*10=0.5s
AGAIN:		MOV TH0,#3CH		;delay for 50ms
			MOV TL0,#0B0H		;50000=C350H;FFFF-C350+1=3CB6H
			SETB TR0
			JNB TF0,$
			CLR TR0
			CLR TF0
			DJNZ R4,AGAIN
			RET
END
			
